open Absyn

exception Error of string

type 'a env = Extend of var list * 'a array * 'a env | Empty

let list_find_position (x:'a) (l:'a list) :int option = 
  let rec helper l i = 
    match l with 
        [] -> None
      | (hd::tl) -> if x = hd then Some i else 
          helper tl (i+1)
  in
    helper l 0
  
let extend_env (vars:var list) (vals:'a list) (old_env:'a env) : 'a env = 
  Extend(vars, Array.of_list vals, old_env)

(* Unlike the old version of apply_env, when the location of the
 * value is found, that is what is returned as a reference.  *)
let rec apply_env (env:'a env) (sym:var) : 'a = 
  match env with 
      Empty -> raise (Error ("Unbound variable " ^ sym))
    | Extend (vars, vals, old_env) -> 
        (match list_find_position sym vars with 
             Some pos -> vals.(pos)
           | None -> apply_env old_env sym)

